/*
 * ServerConnection.java
 *
 * Created on September 13, 2006, 12:35 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package lab3;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.bluetooth.*;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;

/**
 *
 * @author u0307489
 */
public class ServerConnection implements Runnable{
    StreamConnection conn;
    DataOutputStream os;
    String connString=null;
    int X,Y;
    boolean update=false;
    boolean running=true;
 
    public ServerConnection() {
        LocalDevice local;
        DiscoveryAgent agent;
                
   
        try {
           local = LocalDevice.getLocalDevice();
           agent = local.getDiscoveryAgent();
           connString = agent.selectService(
                new UUID("86b4d249fb8844d6a756ec265dd1f6a3", false),
                ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);

        } catch (BluetoothStateException ex) {
            ex.printStackTrace();
        }
        

        
       	try {
	    Thread t = new Thread(this);
	    t.start();
	} catch (Exception e) {
	    e.printStackTrace();
	}
        
       
    }
    
    public void setXY(int x, int y) throws IOException {
        if ((this.X==x)&&(this.Y==y)) {update = false; return;}
	this.X=x;
        this.Y=y;
        update = true;
        
    }

    public void run(){
      try {
            conn = (StreamConnection)
                             Connector.open(connString);
            os = conn.openDataOutputStream();
       } catch (IOException ex) {
                ex.printStackTrace();
       } 
        while(running){
           if (update) {
               try{
               os.writeInt(X);
               os.writeInt(Y);
               update = false;
               }catch(IOException ex){
                   this.close();
                   ex.printStackTrace();
               }
               
           }
        }
    }
    
    public void close(){
        try {
            running = false;
            os.close();        
            conn.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
 
    }
    
}
