/*
 * s2Canvas.java
 *
 * Created on September 5, 2006, 11:41 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package lab3;

import java.io.OutputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.OutputConnection;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;
import lab3.ServerConnection;

/**
 *
 * @author Abg Ein
 */
public class s2Canvas extends GameCanvas implements CommandListener, Runnable {
    Sprite mBlue;
    ServerConnection sc;
    
     private static int STEP = 15;
     private static long FRAMETIME = 40;
    
    /**
     * Creates a new instance of s1Canvas
     */
    public s2Canvas() {
        super(true);
     try{   
          jbInit();
          
          createBlue();
          
          sc = new ServerConnection();
          
          Thread t = new Thread(this);
          t.start();

        }catch(Exception e) {
          e.printStackTrace();
       }
    }
  
   private void createBlue(){
    //create the sprite
    Image mImage = null;
    try{
      mImage = Image.createImage("/lab3/blue.png");
      } catch(IOException e){}
      mBlue = new Sprite(mImage, 15,15);
      mBlue.setPosition((getWidth()/2), getHeight()/2);
      mBlue.defineReferencePixel(7,7);
  }
    
   
   
   public void run() {
        
         Graphics g=getGraphics();
         
         boolean mFlag=true;
         int x2 = mBlue.getX();
         int y2 = mBlue.getY();
         long starttime,endtime,actualtime,delayedtime;
         
         
          while(mFlag){
            starttime = System.currentTimeMillis();
          
            int keyStates = getKeyStates();
            
            if ((keyStates & RIGHT_PRESSED) !=0 ){
                x2=x2+STEP; 
            }
            else if ((keyStates & LEFT_PRESSED) !=0 ){
                x2=x2-STEP; 
            }
            else if ((keyStates & UP_PRESSED) !=0 ){
                y2=y2-STEP;
            }
            else if ((keyStates & DOWN_PRESSED) !=0 ){
                y2=y2+STEP;
            }
            
           g.setColor(255,255,255) ;   // SET color to white
           g.fillRect(0,0,getWidth(),getHeight()); //Clear sprite in the previous screen
            
            mBlue.setPosition(x2,y2);
            mBlue.paint(g);
            
            try {
                sc.setXY(x2,y2);
            } catch (IOException ex) {
                ex.printStackTrace();
            }
            
            g.setColor(0,0,255) ;
            g.drawString(Integer.toString(x2)+" "+Integer.toString(y2),0,0,Graphics.TOP|Graphics.LEFT);
            flushGraphics();

            //try {Thread.sleep(80);}
            //catch (InterruptedException ie){}
            endtime = System.currentTimeMillis();
            actualtime = endtime-starttime;
            System.out.println(actualtime);
            
            if (actualtime<FRAMETIME) {
                try {Thread.sleep(FRAMETIME-actualtime);}
                catch (InterruptedException ie){}
                
            }
            delayedtime = System.currentTimeMillis();
            System.out.println(delayedtime-starttime);
          }
    }


            
   private void jbInit() throws Exception {
    // set up this Displayable to listen to command events
    setCommandListener(this);
    // add the Exit command
    addCommand(new Command("Exit", Command.EXIT, 1));
    //addCommand(new Command("Re-Start", Command.OK , 1));
  }
   
    public void commandAction(Command command, Displayable displayable) {
       if (command.getCommandType() == Command.EXIT) {
          sc.close();
          s2controlMidlet.quitApp();
       }
    }
    
}
